<template>
    <!-- 能介上报数据维护 -->
    <div class="projectwData">
        <div class="box">
            <div class="box-top">
                <el-form
                    style="overflow: hidden;"
                    :style="filterForm.show ? null : { height: '0px' }"
                    size="mini"
                    label-width="70px"
                >
                    <el-row>
                        <el-col :span="6">
                            <el-form-item label="时间粒度">
                                <el-select
                                    filterable clearable
                                    v-model="filterForm.data.timegranid"
                                    placeholder=""
                                    style="width: 100%;"
                                >
                                    <el-option
                                        v-for="item of nameObj.timegranid.arr"
                                        :key="item.id"
                                        :value="item.id"
                                        :label="item.name"
                                    ></el-option>
                                </el-select>
                            </el-form-item>
                        </el-col>
                        <el-col :span="6">
                            <el-form-item label="时间">
                                <zj-timegran-date
                                    v-model="filterForm.data.clock"
                                    style="width: 100%;"
                                    :type="'daterange'"
                                    :timegranId="filterForm.data.timegranid"
                                    :oneFoo="getTableData"
                                    :defaultOffset="-1"
                                ></zj-timegran-date>
                            </el-form-item>
                        </el-col>
                        <el-col :span="6">
                            <el-form-item label="工序">
                                <el-select
                                    filterable
                                    clearable
                                    multiple
                                    collapse-tags
                                    v-model="filterForm.data.workprocid"
                                    placeholder=""
                                    style="width: 100%;"
                                >
                                    <el-option
                                        v-for="item of nameObj.workprocid.arr"
                                        :key="item.id"
                                        :value="item.id"
                                        :label="item.name"
                                    ></el-option>
                                </el-select>
                            </el-form-item>
                        </el-col>
                        <el-col :span="6">
                            <el-form-item label="物料名称">
                                <el-select
                                    filterable
                                    clearable
                                    multiple
                                    collapse-tags
                                    v-model="filterForm.data.energyid"
                                    placeholder=""
                                    style="width: 100%;"
                                >
                                    <el-option
                                        v-for="item of nameObj.energyid.arr"
                                        :key="item.id"
                                        :value="item.id"
                                        :label="item.name"
                                    ></el-option>
                                </el-select>
                            </el-form-item>
                        </el-col>
                    </el-row>
                    <el-row>
                        <el-col :span="6">
                            <el-form-item label="属性">
                                <el-select
                                    filterable
                                    clearable
                                    multiple
                                    collapse-tags
                                    v-model="filterForm.data.propertyid"
                                    placeholder=""
                                    style="width: 100%;"
                                >
                                    <el-option
                                        v-for="item of nameObj.propertyid.arr"
                                        :key="item.id"
                                        :value="item.id"
                                        :label="item.name"
                                    ></el-option>
                                </el-select>
                            </el-form-item>
                        </el-col>
                        <el-col :span="6">
                            <el-form-item label="项目编号">
                                <el-tooltip content="精准查询，多个用逗号隔开" placement="bottom">
                                    <el-input clearable
                                        v-model.trim="filterForm.data.itemid"
                                        placeholder=""
                                        style="width: 100%;"
                                        @keyup.enter.native="getTableData(1)"
                                    ></el-input>
                                </el-tooltip>
                            </el-form-item>
                        </el-col>
                        <!-- <el-col :span="6">
                            <el-form-item label="项目名称">
                                <el-tooltip content="模糊查询" placement="bottom">
                                    <el-input clearable
                                        v-model.trim="filterForm.data.itemname"
                                        placeholder=""
                                        style="width: 100%;"
                                        @keyup.enter.native="getTableData(1)"
                                    ></el-input>
                                </el-tooltip>
                            </el-form-item>
                        </el-col> -->
                        <el-col :span="6">
                            <el-form-item label="项目描述">
                                <el-tooltip content="模糊查询" placement="bottom">
                                    <el-input clearable
                                        v-model.trim="filterForm.data.itemdesc"
                                        placeholder=""
                                        style="width: 100%;"
                                        @keyup.enter.native="getTableData(1)"
                                    ></el-input>
                                </el-tooltip>
                            </el-form-item>
                        </el-col>
                    </el-row>
                </el-form>
                <div class="box-top-gjl">
                    <el-button
                        class="button"
                        type="primary"
                        size="mini"
                        icon ="el-icon-check"
                        @click="but_more()"
                    >保存</el-button>
                      <el-button
                        class="button"
                        type="primary"
                        size="mini"
                        icon="el-icon-delete"
                        v-privilege="activeMenu + 'DELETE'"
                        @click="but_del_plural()"
                        :loading="loading"
                    >清零</el-button>
                    <el-button
                        class="button"
                        type="primary"
                        size="mini"
                        icon="el-icon-refresh"
                        :loading="loading"
                        @click="but_re_compute()"
                    >重新计算</el-button>
                     <el-button
                        class="button"
                        type="primary"
                        size="mini"
                        v-privilege="activeMenu + 'PUT'"
                        @click="but_redata()"
                        :loading="loading"
                    >重新生成数据</el-button>
                    <el-button
                        class="button"
                        type="primary"
                        size="mini"
                        v-privilege="activeMenu + 'PUT'"
                        @click="selectFile()"
                        :loading="loading"
                    >上传财务数据文件</el-button>
                    <input
                        ref="licFile"
                        type="file"
                        style="display: none;"
                        @change="tirggerFile($event)"
                    >
                    <div style="float:right; text-align: right;">
                        <el-tooltip content="每月1、2号早上9点生成上月数据" placement="left">
                            <el-button
                                class="button"
                                type="primary"
                                size="mini"
                                icon="el-icon-search"
                                v-privilege="activeMenu + 'QUERY'"
                                @click="getTableData(1)"
                            >查询</el-button>
                        </el-tooltip>
                        <el-button
                            class="button"
                            type="primary"
                            size="mini"
                            icon="el-icon-refresh"
                            v-privilege="activeMenu + 'QUERY'"
                            @click="tableDataCancel();"
                        >重置</el-button>
                        <el-button
                            size="mini"
                            :icon="filterForm.show ? 'el-icon-caret-top' : 'el-icon-caret-bottom'"
                            :title="filterForm.show ? '收起搜索区' : '展开搜索区'"
                            @click="filterForm.show = !filterForm.show;
                                $nextTick(() => {
                                    singleTableHeight = getRoleHeight($refs['singleTable'].$el) - 45;
                                }
                            );"
                        >{{ filterForm.show ? '收起' : '展开' }}</el-button>
                    </div>
                </div>
            </div>
            <div class="box-bottom">
                <el-form
                    size="mini"
                    ref="dialog_form_arr"
                    label-width="0px"
                    :model="tableFormDataObj"
                >
                    <el-table
                        stripe
                        id="singleTable"
                        ref="singleTable"
                        :data="tableData"
                        v-loading="tableLoading"
                        style="width: 100%;"
                        :height="singleTableHeight"
                        border
                        size="mini"
                        highlight-current-row
                        @selection-change="handleSelectionChange"
                        :row-class-name="tableRowClassName"
                        @cell-click="cellClick"
                        show-summary
                        :summary-method="getSummaries">
                        <el-table-column type="selection" width="40" align="center" fixed="left"></el-table-column>
                        <el-table-column
                        sortable
                            prop="timegranid"
                            label="粒度"
                            width="52px"
                            :show-overflow-tooltip="true"
                        >
                            <template slot-scope="scope">
                                <span>{{ nameObj.timegranid.obj[scope.row.timegranid] ? nameObj.timegranid.obj[scope.row.timegranid] : scope.row.timegranid }}</span>
                            </template>
                        </el-table-column>
                        <el-table-column
                        sortable
                            prop="clock"
                            label="时间"
                            width="75px"
                            :show-overflow-tooltip="true"
                        ></el-table-column>
                        <el-table-column
                            sortable
                            prop="itemid"
                            label="项目编号"
                            width="105px"
                            :show-overflow-tooltip="true"
                        ></el-table-column>
                        <el-table-column
                            sortable
                            prop="workprocid"
                            label="工序"
                            width="101px"
                            :show-overflow-tooltip="true"
                            :sort-by="function(row, index) { return sortFoo(row, index, 'workprocid') }"
                        >
                            <template slot-scope="scope">
                                <span>{{ nameObj.workprocid.obj[scope.row.workprocid] ? nameObj.workprocid.obj[scope.row.workprocid] : scope.row.workprocid }}</span>
                            </template>
                        </el-table-column>
                        <el-table-column
                            sortable
                            prop="energyid"
                            label="物料名称"
                            width="95px"
                            :show-overflow-tooltip="true"
                            :sort-by="function(row, index) { return sortFoo(row, index, 'energyid') }"
                        >
                            <template slot-scope="scope">
                                <span>{{ nameObj.energyid.obj[scope.row.energyid] ? nameObj.energyid.obj[scope.row.energyid] : scope.row.energyid }}</span>
                            </template>
                        </el-table-column>
                        <el-table-column
                            sortable
                            prop="propertyid"
                            label="属性"
                            width="60px"
                            :show-overflow-tooltip="true"
                            :sort-by="function(row, index) { return sortFoo(row, index, 'propertyid') }"
                        >
                            <template slot-scope="scope">
                                <span>{{ nameObj.propertyid.obj[scope.row.propertyid] ? nameObj.propertyid.obj[scope.row.propertyid] : scope.row.propertyid }}</span>
                            </template>
                        </el-table-column>
                        <!-- <el-table-column
                            sortable
                            prop="itemname"
                            label="项目名称"
                            width="175px"
                            :show-overflow-tooltip="true"
                        ></el-table-column> -->
                        <el-table-column
                            sortable
                            prop="itemdesc"
                            label="项目描述"
                            width="165px"
                            :show-overflow-tooltip="true"
                        ></el-table-column>
                        <el-table-column
                            sortable
                            prop="productvalue"
                            label="系统数据(t)"
                            align="right"
                            width="88px"
                            :show-overflow-tooltip="true"
                        ></el-table-column>
                        <el-table-column
                            sortable
                            prop="defaultvalue"
                            align="right"
                            label="波动系数(%)"
                            width="88px"
                            :show-overflow-tooltip="true"
                        ></el-table-column>
                        <!-- <el-table-column
                            sortable
                            prop="ucvalue"
                            label="系统单耗"
                            align="right"
                            width="80px"
                            :show-overflow-tooltip="true"
                        > </el-table-column> -->
                        <!-- <el-table-column
                            sortable
                            prop="ucwvalue0"
                            label="上报单耗"
                            align="right"
                            width="80px"
                            :show-overflow-tooltip="true"
                        ></el-table-column> -->
                        <!-- <el-table-column
                            sortable
                            prop="apportvalue"
                            label="系统最终值"
                            align="right"
                            width="85px"
                            :show-overflow-tooltip="true"
                        ></el-table-column> -->
                        <!-- <el-table-column
                            sortable
                            prop="stdvalue"
                            label="系统折标值"
                            width="118px"
                            :show-overflow-tooltip="true"
                        ></el-table-column> -->
                        <!-- <el-table-column
                            sortable
                            prop="productwvalue"
                            label="上报产量(t)"
                            align="right"
                            width="85px"
                            :show-overflow-tooltip="true"
                        ></el-table-column> -->
                        <el-table-column
                            sortable
                            prop="apportwvalue"
                            label="财务最终值"
                            align="right"
                            width="110px"
                            :show-overflow-tooltip="true"
                        >
                            <template slot-scope="scope">
                                <el-form-item
                                    v-if="scope.row.isSelection"
                                    :prop="'s' + scope.row.seq + '.apportwvalue'"
                                    :rules="tableFormRules.numbers"
                                >
                                    <el-input clearable
                                        style="width: 100%;" @keydown.native="keyDown" :id="scope.column.id + scope.$index"
                                        v-model.trim="tableFormDataObj['s' + scope.row.seq].apportwvalue"
                                        refcous="true"
                                        @change="getUcwvalue(scope.row.seq, 's' + scope.row.seq)"
                                    ></el-input>
                                </el-form-item>
                                <span v-else>{{scope.row.apportwvalue}}</span>
                            </template>
                        </el-table-column>
                        <el-table-column
                            sortable
                            prop="unitid"
                            label="最终单位"
                            width="70px"
                            :show-overflow-tooltip="true"
                        >
                            <template slot-scope="scope">
                                <span>{{ nameObj.unitid.obj[scope.row.unitid] ? nameObj.unitid.obj[scope.row.unitid] : scope.row.unitid }}</span>
                            </template>
                        </el-table-column>
                        <el-table-column
                            sortable
                            prop="upuser"
                            label="确认人"
                            width="65px"
                            :show-overflow-tooltip="true">
                        </el-table-column>
                        <el-table-column
                            sortable
                            prop="uptime"
                            label="确认时间"
                            width="125px"
                            :show-overflow-tooltip="true"
                        ></el-table-column>
                        <el-table-column
                            sortable
                            prop="createman"
                            label="创建人"
                            width="65px"
                            :show-overflow-tooltip="true"
                        ></el-table-column>
                        <el-table-column
                            sortable
                            prop="rectime"
                            label="创建时间"
                            min-width="125px"
                            :show-overflow-tooltip="true"
                        ></el-table-column>
                        <el-table-column
                            class-name="gn-TableDownloadExcel-none"
                            label="操作"
                            align="center"
                            width="85px"
                            fixed="right"
                        >
                            <template slot-scope="scope">
                                <div>
                                    <el-button
                                        type="primary"
                                        size="mini"
                                        @click="but_sdata(scope.row)"
                                    >计算过程</el-button>
                                </div>
                            </template>
                        </el-table-column>
                    </el-table>
                </el-form>
                <el-pagination
                    layout="total, sizes, prev, pager, next, jumper"
                    :total="total"
                    :page-sizes="[10, 20, 50, 100, 500, 1000]"
                    :page-size="pageSize"
                    :current-page.sync="pageNum"
                    @size-change="tableSizeChange"
                    @current-change="getTableData()"
                    style="text-align: right;margin-top: 10px;"
                ></el-pagination>
            </div>
        </div>
    </div>
</template>

<script>
import { zCheckNumber1 } from '@/utils/validator.js'
import store from '@/store/index.js';
import timegranDate from '@/components/zg/timegranDate.vue'
import {formatDate, commonSummaries} from '@/utils/util.js';
export default {
    name: 'financeProjectData',
    components: {
        'zj-timegran-date': timegranDate
    },
    data () {
        let start = new Date(new Date().getFullYear(), new Date().getMonth() - 1, '01');
        return {
            rowIndex: '',
            columnId: '',
            focusTarget: null,
            seqArr: [],
            editSetFlag: '',
            multipleSelection: [],
            tableFormDataObj: {},
            store,
            activeMenu: '',
            filterForm: {
                show: true,
                data: {
                    timegranid: 'DAY',
                    clock: [formatDate(start, 'yyyy-MM-DD'), formatDate(start, 'yyyy-MM-DD')],
                    workprocid: '',
                    energyid: '',
                    propertyid: '',
                    itemid: '',
                    itemname: '',
                    itemdesc: ''
                },
                rules: {}
            },
            tableFormRules: {
                numbers: [
                    { validator: zCheckNumber1, trigger: 'change' }
                ]
            },
            pageNum: 1,
            pageSize: 100,
            total: 0,
            singleTableHeight: 100,
            tableData: [],
            nameObj: {
                timegranid: {
                    obj: {
                        'DAY': '日',
                        'MONTH': '月',
                        'YEAR': '年'
                    },
                    arr: [{id: 'DAY', name: '日'}, {id: 'MONTH', name: '月'}, {id: 'YEAR', name: '年'}]
                },
                workprocid: {
                    obj: {},
                    arr: []
                },
                energyid: {
                    obj: {},
                    arr: []
                },
                propertyid: {
                    obj: {},
                    arr: []
                },
                unitid: {
                    obj: {},
                    arr: []
                }
            },
            loading: false,
            tableLoading: false,
            dialog: {
                editorBox: {
                    type: '',
                    form: {
                        data: {
                            itemid: '',
                            clock: '',
                            timegranid: '',
                            actualvalue: '',
                            correctvalue: ''
                        },
                        rules: {
                            correctvalue: [
                                { required: true, message: '该项不能为空', trigger: 'change' },
                                { validator: zCheckNumber1, trigger: 'change' }
                            ]
                        }
                    }
                }
            }
        }
    },
    created () {
        this.activeMenu = window.localStorage.getItem('activeMenu');
    },
    mounted () {
        let that = this;
        window.PEDataObj = {
            // 将数据绑定到window上，供main页面使用
            vm: that,
            // tableArr：用于导出成Excel的表格的信息
            tableArr: [
                {
                    name: '',
                    id: 'singleTable'
                }
            ]
        };
        that.$nextTick(() => {
            // 立即获取的height有一定偏差，通过setTimeout延迟来解决
            setTimeout(() => {
                that.singleTableHeight = that.getRoleHeight(that.$refs['singleTable'].$el) - 45;
            }, 1);
        });
        that.getEnergyIdData();
        that.getWorkprocIdData();
        that.getPropertyIdData();
        that.getUnitIdData();
        that.getTableData();
    },
    methods: {
        //  计算树区域高度
        getRoleHeight (dom) {
            return window.innerHeight - dom.offsetTop;
        },
        // 用于表格特殊列的过滤方法（:sort-by="function(row, index) { return sortFoo() }"）
        sortFoo (row, index, objName, name) {
            name = name || objName;
            let s = this.nameObj[objName].obj[row[name]] ? this.nameObj[objName].obj[row[name]] : row[name];
            return s;
        },
        // 自定义的表格合计方法：只给指定列进行合计
        getSummaries (param) {
            const prop = ['apportwvalue', 'productvalue', 'productwvalue']; // 合计列绑定的prop
            return commonSummaries(param, prop);
        },
        // 获取工序(供需实际)
        getWorkprocIdData () {
            let that = this;
            let url = 'pass/ems/v1/trmworkprocs/getIdAndName?hasproduct=1'; // ZYA000,ZY1000
            that.axios.get(url)
                .then(function (res) {
                    if (res.code === '0') {
                        let arr = [];
                        let obj = {};
                        for (let item of res.data) {
                            arr.push({
                                id: item.id,
                                name: item.name
                            })
                            obj[item.id] = item.name;
                        }
                        that.nameObj.workprocid.arr = arr;
                        that.nameObj.workprocid.obj = obj;
                    } else {
                        that.$message.error(res.message);
                    }
                });
        },
        // 获取能介(供需实际)
        getEnergyIdData () {
            let that = this
            let urlm = 'pass/ems/v1/trmworkprocmaterials/listFinanceData/';
            let urlp = 'pass/ems/v1/trmworkprocproducts/listFinanceData/';
            let datas = [];
            let datasObj = [];
            function showdatas () {
                that.nameObj.energyid.arr = datas;
                let objs = {};
                for (let item of datas) {
                    objs[item.id] = item.name;
                }
                that.nameObj.energyid.obj = objs;
            }
            that.axios.get(urlm)
                .then(function (res) {
                    if (res.code === '0') {
                        let arr = [];
                        for (let item of res.data) {
                            arr.push({
                                id: item.ID,
                                name: item.NAME
                            })
                        }
                        datas = datas.concat(arr);
                        showdatas();
                    } else {
                        that.$message.error(res.message);
                    }
                });
            that.axios.get(urlp)
                .then(function (res) {
                    if (res.code === '0') {
                        let arr = [];
                        for (let item of res.data) {
                            arr.push({
                                id: item.ID,
                                name: item.NAME
                            })
                        }
                        datas = datas.concat(arr);
                        showdatas();
                    } else {
                        that.$message.error(res.message);
                    }
                });
        },
        // 获取属性
        getPropertyIdData () {
            let that = this
            let url = 'pass/ems/v1/trmenergypropertys/getidandname/';
            that.axios.get(url)
                .then(function (res) {
                    if (res.code === '0') {
                        let arr = [];
                        let obj = {};
                        for (let item of res.data) {
                            arr.push({
                                id: item.id,
                                name: item.name
                            })
                            obj[item.id] = item.name;
                        }
                        that.nameObj.propertyid.arr = arr;
                        that.nameObj.propertyid.obj = obj;
                    } else {
                        that.$message.error(res.message);
                    }
                });
        },
        // 获取标准计量单位
        getUnitIdData () {
            let that = this
            let url = 'pass/ems/v1/trmunits/getIdAndName';
            that.axios.get(url)
                .then(function (res) {
                    if (res.code === '0') {
                        let arr = [];
                        let obj = {};
                        for (let item of res.data) {
                            arr.push({
                                id: item.id,
                                name: item.name
                            })
                            obj[item.id] = item.name;
                        }
                        that.nameObj.unitid.arr = arr;
                        that.nameObj.unitid.obj = obj;
                    } else {
                        that.$message.error(res.message);
                    }
                });
        },
        // 获取表格中的数据
        getTableData (pageNum) {
            let that = this,
                params = {
                    timegranid: that.filterForm.data.timegranid,
                    startDate: that.filterForm.data.clock[0],
                    endDate: that.filterForm.data.clock[1],
                    workprocid: that.filterForm.data.workprocid.toString(),
                    energyid: that.filterForm.data.energyid.toString(),
                    propertyid: that.filterForm.data.propertyid.toString(),
                    itemid: that.filterForm.data.itemid,
                    itemname: that.filterForm.data.itemname,
                    itemdesc: that.filterForm.data.itemdesc
                };
            that.pageNum = pageNum || that.pageNum;
            that.tableLoading = true;
            let url = 'pass/ems/v1/trmdfvalues/getProjectwData/?pageNum=' + that.pageNum + '&pageSize=' + that.pageSize;
            that.axios.get(url, {
                params: params
            })
                .then(function (res) {
                    if (res.code === '0') {
                        let arr = [];
                        for (let i = 0; i < res.data.list.length; i++) {
                            let item = res.data.list[i];
                            arr.push({
                                seq: i,
                                itemid: item.ITEMID,
                                clock: item.CLOCK,
                                timegranid: item.TIMEGRANID,
                                itemname: item.ITEMNAME,
                                itemdesc: item.ITEMDESC,
                                unitid: item.UNITID,
                                productvalue: item.PRODUCTVALUE,
                                apportvalue: item.APPORTVALUE,
                                stdvalue: item.STDVALUE,
                                ucvalue: item.UCVALUE,
                                productwvalue: item.PRODUCTWVALUE,
                                apportwvalue: item.APPORTWVALUE,
                                stdwvalue: item.STDWVALUE,
                                ucwvalue: item.UCWVALUE,
                                ucwvalue0: item.UCWVALUE,
                                workprocid: item.WORKPROCID,
                                energyid: item.ENERGYID,
                                propertyid: item.PROPERTYID,
                                seqno: item.SEQNO,
                                showno: item.SHOWNO,
                                createman: item.CREATEMAN,
                                rectime: item.REC_TIME,
                                upuser: item.UPUSER,
                                uptime: item.UPTIME,
                                defaultvalue: item.DEFAULTVALUE
                            })
                        }
                        that.tableData = arr;
                        that.total = res.data.total;
                    } else {
                        that.$message.error(res.message);
                    }
                    that.tableLoading = false;
                }).catch(function () {
                    that.tableLoading = false;
                });
        },
        // 改变表格显示条数
        tableSizeChange (val) {
            let that = this;
            that.pageSize = val;
            that.getTableData(1);
        },
        // 重置搜索
        tableDataCancel () {
            let that = this;
            for (let key in that.filterForm.data) {
                if (that.filterForm.data[key] instanceof Array) {
                    that.filterForm.data[key] = [];
                } else {
                    that.filterForm.data[key] = '';
                }
            }
            that.getTableData(1);
        },
        // 计算上报单耗值
        getUcwvalue (seq, ids) {
            let that = this;
            if (that.tableFormDataObj[ids].apportwvalue && that.tableFormDataObj[ids].productwvalue) {
                let apportwvalue = that.floatComputed(that.tableFormDataObj[ids].apportwvalue, that.tableFormDataObj[ids].defaultvalue, '*');
                let ucwvalue = that.floatComputed(apportwvalue, that.tableFormDataObj[ids].productwvalue, '/');
                that.tableFormDataObj[ids].ucwvalue0 = Number(ucwvalue).toFixed(3);
                that.showRealValue(seq, that.tableFormDataObj[ids].ucwvalue0);
            }
        },
        // 展示上报单耗值
        showRealValue (seq, value) {
            let that = this;
            for (let i = 0; i < that.tableData.length; i++) {
                if (that.tableData[i].seq === seq) {
                    that.tableData[i].ucwvalue0 = value;
                }
            }
        },
        // 批量重新计算
        but_re_compute () {
            let that = this;
            if (that.multipleSelection.length > 0) {
                that.$refs['dialog_form_arr'].validate((valid) => {
                    if (valid) {
                        let SubmitData = [];
                        for (let key in that.tableFormDataObj) {
                            SubmitData.push({
                                clock: that.tableFormDataObj[key].clock,
                                timegranid: that.tableFormDataObj[key].timegranid,
                                itemid: that.tableFormDataObj[key].itemid
                            });
                        }
                        that.loading = true;
                        that.axios.put('pass/ems/v1/trmdfvalues/batchCompute', SubmitData)
                            .then(function (res) {
                                if (res.code === '0') {
                                    that.$message({
                                        message: '重新计算成功',
                                        type: 'success'
                                    });
                                    that.getTableData();
                                } else {
                                    that.$message.error(res.message);
                                }
                                that.loading = false;
                            }).catch(function () {
                                that.loading = false;
                            });
                    }
                });
            } else {
                this.$message.error('至少要选择一条数据');
            }
        },
        // 批量修改
        but_more () {
            let that = this;
            if (that.multipleSelection.length > 0) {
                that.$refs['dialog_form_arr'].validate((valid, obj) => {
                    if (valid) {
                        let SubmitData = [];
                        for (let obj in that.tableFormDataObj) {
                            SubmitData.push({
                                itemid: that.tableFormDataObj[obj].itemid,
                                clock: that.tableFormDataObj[obj].clock,
                                timegranid: that.tableFormDataObj[obj].timegranid,
                                apportwvalue: that.tableFormDataObj[obj].apportwvalue
                            })
                        }
                        that.loading = true;
                        that.axios.put('pass/ems/v1/trmdfvalues/batchUpdate', SubmitData)
                            .then(function (res) {
                                if (res.code === '0') {
                                    that.$message({
                                        message: '修改成功',
                                        type: 'success'
                                    });
                                    that.getTableData();
                                } else {
                                    that.$message.error(res.message);
                                }
                                that.loading = false;
                            }).catch(function () {
                                that.loading = false;
                            });
                    } else {
                        let col = Object.keys(obj)[0].split('.')[1];
                        if (col && col === 'correctvalue') {
                            this.$message.error('请填写正确的修正值');
                        } else {
                            this.$message.error('数据不完整或者格式错误');
                        }
                    }
                });
            } else {
                this.$message.error('至少要选择一条数据');
            }
        },
        // 表格中多选按钮的相关方法
        handleSelectionChange (val) {
            let that = this;
            let tableFormDataObj = {};
            let arr = [];
            for (let item of val) {
                arr.push(item.seq);
            }
            this.seqArr = arr.sort(sortNumber);
            for (let item of that.tableData) {
                item.isSelection = false;
            }
            for (let item of val) {
                let obj = {};
                let xId = 's' + item.seq;
                if (that.tableFormDataObj[xId]) {
                    tableFormDataObj[xId] = that.tableFormDataObj[xId];
                } else {
                    for (let key in item) {
                        obj[key] = item[key];
                    }
                    tableFormDataObj[xId] = obj;
                }
                item.isSelection = true;
            }
            for (let item of that.tableData) {
                if (item.isSelection === false) {
                    item.ucwvalue0 = item.ucwvalue;
                }
            }
            that.tableFormDataObj = tableFormDataObj;
            that.multipleSelection = val;
        },
        tableRowClassName ({row, rowIndex}) {
            // 把每一行的索引放进row
            row.index = rowIndex;
        },
        cellClick (row, column, cell, event) {
            let _this = this;
            this.rowIndex = row.index;
            this.columnId = column.id;
            _this.editSetFlag = column.id + row.index;
            _this.focusTarget = event.target;
            while (_this.focusTarget.tagName !== 'TD') {
                _this.focusTarget = _this.focusTarget.parentElement;
            }
            _this.$nextTick(() => {
                let target = this.focusTarget;
                $(target).find('input').focus();
            });
        },
        keyDown (event1) {
            let tdTarget = event1.target;
            let _this = this;
            while (tdTarget.tagName !== 'TD') {
                tdTarget = tdTarget.parentElement;
            }
            // 如果按下键盘下键或者回车键
            if (event.keyCode === 40 || event.keyCode === 13) {
                let index = parseInt(this.rowIndex);
                if (index !== this.seqArr[this.seqArr.length - 1]) {
                    for (let i = 0; i < this.seqArr.length; i++) {
                        if (index === this.seqArr[i]) {
                        index = this.seqArr[i + 1];
                        break;
                        }
                    }
                }
                this.editSetFlag = this.columnId + index;
                let id = '#' + this.editSetFlag;
                this.$nextTick(() => {
                    $(id).click();
                });
            } else if (event.keyCode === 38) { // 键盘上键
                let index = parseInt(this.rowIndex);
                if (index !== this.seqArr[0]) {
                    for (let i = 0; i < this.seqArr.length; i++) {
                        if (index === this.seqArr[i]) {
                        index = this.seqArr[i - 1];
                        break;
                        }
                    }
                }
                this.editSetFlag = this.columnId + index;
                let id = '#' + this.editSetFlag;
                this.$nextTick(() => {
                    $(id).click();
                });
            } else if (event.keyCode === 37) { // 键盘左键
                $(tdTarget).prev().click();
                $(tdTarget).prev().find('input').select();
            } else if (event.keyCode === 39) { // 键盘右键
                $(tdTarget).next().click();
                $(tdTarget).next().find('input').select();
            }
        },
        // 重新生成数据
        but_redata () {
            let that = this;
            if (!that.filterForm.data.clock || that.filterForm.data.clock.length === 0) {
                that.$message.warning('请选择日期范围');
                return true;
            }
            if (!that.filterForm.data.clock[0] || !that.filterForm.data.clock[1]) {
                that.$message.warning('请选择开始日期与结束日期');
                return true;
            }
            if (!that.filterForm.data.timegranid) {
                that.$message.warning('请选择时间粒度');
                return true;
            }
            let params = {
                timegranid: that.filterForm.data.timegranid,
                clock: that.filterForm.data.clock[0], // 开始时间
                clocke: that.filterForm.data.clock[1], // 结束时间
                workprocid: that.filterForm.data.workprocid.toString(), // 工序
                energyid: that.filterForm.data.energyid.toString(), // 能介
                propertyid: that.filterForm.data.propertyid.toString(), // 用能属性
                itemid: that.filterForm.data.itemid, // 项目编号
                itemname: that.filterForm.data.itemname, // 项目名称
                itemdesc: that.filterForm.data.itemdesc, // 项目描述
                itemtype: 'F' // 上报项目
            };
            that.$confirm('是否重新生成数据？日期跨度不易太长！否则运行时间较长', '提示', {
                confirmButtonText: '确定',
                cancelButtonText: '取消',
                state: 'warning'
            }).then(() => {
                that.loading = true;
                let url = 'pass/ems/v1/trmactitems/reData'
                that.axios.get(url, {
                    params: params
                })
                    .then(function (res) {
                        if (res.code === '0') {
                            if (res.message && res.message !== '操作成功') {
                                that.$message.warning('重新生成数据成功, 其中【' + res.message + '】');
                            } else {
                                that.$message({
                                    message: '重新生成数据成功',
                                    type: 'success'
                                });
                            }
                            that.getTableData();
                        } else {
                            that.$message.error(res.message);
                        }
                        that.loading = false;
                    }).catch(function () {
                        that.loading = false;
                    });
            }).catch(() => {
            });
        },
        // 计算过程
        but_sdata (row) {
            let that = this;
            let params = {
                timegranid: row.timegranid,
                clock: row.clock, // 开始时间
                itemid: row.itemid // 项目编号
            };
            that.axios.get('pass/ems/v1/formulas/getAnaByVal/', {
                params: params
            }).then(function (res) {
                if (res.code === '0') {
                    that.$message({
                        dangerouslyUseHTMLString: true,
                        message: res.data,
                        type: 'success'
                    });
                } else {
                    that.$message.error(res.message);
                }
            }).catch(function () {});
        },
        // 上传文件按钮
        selectFile () {
            let that = this;
            that.$refs['licFile'].click();
        },
       // 清空
       but_del_plural () {
            let that = this;
            if (that.multipleSelection.length > 0) {
                that.$refs['dialog_form_arr'].validate((valid, obj) => {
                    if (valid) {
                        let SubmitData = [];
                        for (let obj in that.tableFormDataObj) {
                            SubmitData.push({
                                itemid: that.tableFormDataObj[obj].itemid,
                                clock: that.tableFormDataObj[obj].clock,
                                timegranid: that.tableFormDataObj[obj].timegranid
                            })
                        }
                        that.loading = true;
                        that.axios.put('pass/ems/v1/trmdfvalues/del', SubmitData)
                            .then(function (res) {
                                if (res.code === '0') {
                                    that.$message({
                                        message: '修改成功',
                                        type: 'success'
                                    });
                                    that.getTableData();
                                } else {
                                    that.$message.error(res.message);
                                }
                                that.loading = false;
                            }).catch(function () {
                                that.loading = false;
                            });
                    }
                });
            } else {
                this.$message.error('至少要选择一条数据');
            }
        },
        // 选择文件上传
        tirggerFile ($event) {
            let that = this;
            if (event.target.files[0]) {
                that.loading = true;
                that.tableLoading = true;
                // console.log('文件名', event.target.files[0].name);
                let fileData = new FormData();
                fileData.append('file', event.target.files[0]);
                that.axios.put('pass/ems/v1/trmdfvalues/uploadExl', fileData, {headers: {'Content-Type': 'multipart/form-data'}}).then(function (res) {
                    if (res.code === '0') {
                        let msg = '上传成功';
                        if (res.data) {
                            msg = '【' + res.data + '】 财务数据上传成功';
                        }
                        that.$message({
                            message: msg,
                            type: 'success'
                        });
                        that.getTableData();
                    } else {
                        that.$message.error(res.message);
                    }
                    that.$refs['licFile'].value = '';
                    that.loading = false;
                    that.tableLoading = false;
                }).catch(function () {
                    that.$refs['licFile'].value = '';
                    that.loading = false;
                    that.tableLoading = false;
                });
            }
        }
    }
}
function sortNumber (a, b) {
  return a - b
}
</script>

<style lang="less">
.projectwData {
    min-width: 700px;
    height: 100%;
    .box {
        height: 100%;
        padding: 15px 15px 0 15px;
        .box-top {
            .el-form-item {
                margin-bottom: 7px;
            }
            .box-top-gjl {
                overflow: hidden;
                padding: 7px 0;
                border-top: 1px solid #ccc;
                // margin-bottom: 6px;
            }
        }
    }
    .el-table__body .el-form-item--mini.el-form-item {
        margin: 0px;
        .error {
            overflow: hidden;
            color: #f56c6c;
            font-size: 12px;
            line-height: 1;
        }
    }
    .el-table__body input {
        font-weight: normal;
        padding-left: 8px;
        padding-right: 25px;
    }
}
</style>
